use crate::protobuf::rpc;

const SUBJECT: &str = "bet.beteran.c2se.common.identity";

pub const SUBJECT_CHECK_USERNAME_FOR_DUPLICATION: &str =
  const_format::concatcp!(SUBJECT, ".CheckUsernameForDuplication");
/// subject = bet.beteran.c2se.common.identity.CheckUsernameForDuplication;
#[derive(Clone, PartialEq, ::prost::Message)]
pub struct CheckUsernameForDuplicationRequest {
  #[prost(string, tag = "1")]
  pub username: ::prost::alloc::string::String,
}
#[derive(Clone, PartialEq, ::prost::Message)]
pub struct CheckUsernameForDuplicationResponse {
  #[prost(message, optional, tag = "1")]
  pub error: ::core::option::Option<rpc::Error>,
  #[prost(message, optional, tag = "2")]
  pub result: ::core::option::Option<check_username_for_duplication_response::Result>,
}
/// Nested message and enum types in `CheckUsernameForDuplicationResponse`.
pub mod check_username_for_duplication_response {
  #[derive(Clone, PartialEq, ::prost::Message)]
  pub struct Result {
    #[prost(bool, tag = "1")]
    pub duplicated: bool,
  }
}
pub const SUBJECT_CHECK_NICKNAME_FOR_DUPLICATION: &str =
  const_format::concatcp!(SUBJECT, ".CheckNicknameForDuplication");
/// subject = bet.beteran.c2se.common.identity.CheckNicknameForDuplication;
#[derive(Clone, PartialEq, ::prost::Message)]
pub struct CheckNicknameForDuplicationRequest {
  #[prost(string, tag = "1")]
  pub nickname: ::prost::alloc::string::String,
}
#[derive(Clone, PartialEq, ::prost::Message)]
pub struct CheckNicknameForDuplicationResponse {
  #[prost(message, optional, tag = "1")]
  pub error: ::core::option::Option<rpc::Error>,
  #[prost(message, optional, tag = "2")]
  pub result: ::core::option::Option<check_nickname_for_duplication_response::Result>,
}
/// Nested message and enum types in `CheckNicknameForDuplicationResponse`.
pub mod check_nickname_for_duplication_response {
  #[derive(Clone, PartialEq, ::prost::Message)]
  pub struct Result {
    #[prost(bool, tag = "1")]
    pub duplicated: bool,
  }
}
pub const SUBJECT_CAPTCHA: &str = const_format::concatcp!(SUBJECT, ".Captcha");
/// subject = bet.beteran.c2se.common.identity.Captcha
#[derive(Clone, PartialEq, ::prost::Message)]
pub struct CaptchaRequest {}
#[derive(Clone, PartialEq, ::prost::Message)]
pub struct CaptchaResponse {
  #[prost(message, optional, tag = "1")]
  pub error: ::core::option::Option<rpc::Error>,
  #[prost(message, optional, tag = "2")]
  pub result: ::core::option::Option<captcha_response::Result>,
}
/// Nested message and enum types in `CaptchaResponse`.
pub mod captcha_response {
  #[derive(Clone, PartialEq, ::prost::Message)]
  pub struct Result {
    #[prost(string, tag = "1")]
    pub token: ::prost::alloc::string::String,
    #[prost(string, tag = "2")]
    pub image: ::prost::alloc::string::String,
  }
}
